#include <zephyr.h>
#include <errno.h>
#include <stdio.h>

#include <net/socket.h>
#include <linker/sections.h>
#include <shell/shell.h>
#include <net/net_core.h>
//#include <drivers/nrf_radio_802154/nrf_802154.h>

#define MY_PORT 4242
#define PEER_PORT 4242

void main()
{
        printk("Starting the Process ... \n") ; 
	struct sockaddr_in6 addr6, addr_peer;
	int sock_id = 0 ; 
	int ret = 0 ;  
	char msg[] = "HELLO\n" ; 
        char msg1[100] ; 
        /*u32_t start_time;
        u32_t stop_time;
        u32_t cycles_spent;
        u32_t nanoseconds_spent;*/
 


	memset(&addr6, 0, sizeof(addr6));
	addr6.sin6_family = AF_INET6;
	addr6.sin6_port = htons(MY_PORT);
	inet_pton(AF_INET6, CONFIG_NET_CONFIG_MY_IPV6_ADDR,
			  &addr6.sin6_addr);
	sock_id = socket(AF_INET6, SOCK_STREAM, IPPROTO_TCP);
	if(sock_id == -1)
	{
		printk("Error in creating socket \n") ; 
		return ; 
	}
	
	ret = bind(sock_id, (struct sockaddr *) &addr6, sizeof(addr6)) ; 
	
        if(ret < 0)
        {
                printk("Error in Binding the Socket \n") ; 
                return ; 
        }
        memset(&addr_peer, 0, sizeof(addr_peer)); 
        addr_peer.sin6_family = AF_INET6;
        addr_peer.sin6_port = htons(PEER_PORT);
        inet_pton(AF_INET6, CONFIG_NET_CONFIG_PEER_IPV6_ADDR,
                  &addr_peer.sin6_addr);
        if(connect(sock_id, (struct sockaddr *) &addr_peer, sizeof(struct sockaddr_in6)) == -1)
        {
              printk("Error in Connect \n") ; 
              return ; 
        }
	while(true)
	{
		/* Continously send message to a server after every 5 seconds */
		
                //start_time = k_cycle_get_32();
                ret = sendto(sock_id, msg, sizeof(msg), 0, (struct sockaddr *)&addr_peer, sizeof(addr_peer)) ;
		if(ret < 0)
		{
			printk("Error in Transmitting the Message \n"); 
			return ; 
		}
                else
                {
                        printk("The message has been transmitted \n") ;
                        ret = recv(sock_id, (void*) msg1, sizeof(msg1), 0) ;
                        printk("%s\n" ,msg) ; 
                        /*stop_time = k_cycle_get_32();
                        cycles_spent = stop_time - start_time;
                        nanoseconds_spent = k_cyc_to_ns_ceil32(cycles_spent) ; //SYS_CLOCK_HW_CYCLES_TO_NS(cycles_spent);*/
                }
		//printk("Time spent is %ul\n", nanoseconds_spent) ;
                memset(msg1, sizeof(msg1), 0) ; 
		k_msleep(500) ;
	}
	return ; 
}